//===============================================================================
//===============================================================================
//
//								    TestPicker.h
//
//								  john calhoun 1997
//
//===============================================================================
//===============================================================================


#include <ColorPicker.h>
#include <QDOffscreen.h>


#define kLineThick		4


typedef struct PickerColorWorld
{
	CMWorldRef		cw;
	CMWorldRef		cw2;
	OSType			srcSpace;
	OSType			dstSpace;
	OSType			srcProfSpace;
	OSType			prfProfSpace;
	OSType			dstProfSpace;
	Boolean			matchingNeeded;
	
} PickerCWRec, *PickerCWPtr;


			// TestPicker.c
void SimpleGetColor (void);
void PickColorMovableModal (long);
void NPickColorMovableModal (void);
void NPickColorCMYK (void);

			// TestPickerInterface.c
void UpdateVennColors (void);
void UpdateCMYKColors (void);
void UpdateBouncingLine (void);
void UpdateMainWindowText (void);
void DoAKeyDownEvent (EventRecord *);
void DoActivateEvent (EventRecord *);
Boolean DoUpdateEvent (EventRecord *);
Boolean DoAppleMenu (short);
Boolean DoPickerMenu (short);
Boolean DoMenuChoice (long);
void EventLoop (void);

			// TestPickerUtil.c
void InitToolbox (void);
short WhatsOurDepth (void);
short RandomInt (short);
void OpenSimpleWindow (void);
void AddMenusToMenuBar (void);
void DebugNum (long);
void PasStringCopy (StringPtr, StringPtr);
void PasStringConcat (StringPtr, StringPtr);
void AllocateVennColorDiagramRegions (void);
void SetUpCMYKRects (void);
void SetUpBounceLine (void);
void PickerMatchColors (PickerCWPtr, CMColor *, UInt32);
void PickerMatchColorsSimple (CMColor *, UInt32, OSType, OSType);
OSType GetProfileColorSpace (CMProfileRef);
OSErr NPickerNewColorWorld (PickerCWPtr, CMProfileRef, CMProfileRef, 
		CMProfileRef, OSType, OSType);
void PickerDisposeColorWorld (PickerCWPtr);
CMError OpenProfileHandle(CMProfileRef *, Handle, UInt32, UInt32);


extern PickerCWRec		syncWorld;
extern CMColor			cmykColor;
extern RgnHandle		wholeVenn, regionR, regionG, regionB, blackRgn;
extern RgnHandle		regionRG, regionGB, regionBR, regionRGB;
extern Rect				windowBounds, rectC, rectM, rectY, rectK, bounceRect;
extern RGBColor			theRGBColor;
extern GWorldPtr		theGWorld;
extern MenuRef			appleMenu, fileMenu, editMenu, testMenu;
extern WindowRef		simpleWindow;
extern UInt32			wasTicks;
extern SInt16			x1, y1, x2, y2, deltaX1, deltaX2, deltaY1, deltaY2;
extern Boolean			quitting, memoryAlert, resForkAlert;

